解决try-catch捕获异常信息后Spring事务失效的问题

一、首先在Spring Boot项目中,手动添加异常方法进行测试

@Transactional(rollbackFor=Exception.class) //表示此方法有异常时触发Spring事务
@Override
public CommonResult<User> saveUser(User user) {
    int insert = baseMapper.insert(user);
    try {
        // 添加异常,并进行捕获
        int a = 10/0;
    }catch (Exception e){
        logger.info("打印异常信息:"+e);
        return CommonResult.commentFailure("服务器异常,事务回滚");
    }
    if(insert > 0){
        return CommonResult.commentSuccess(user);
    }else {
        return CommonResult.commentFailure("添加失败");
    }
}

1、一个添加信息的实现类方法上,此处我们加了Spring的事务。

2、问题:一个方法报异常(int a = 10/0)进行了异常捕获,另一个方法不会回滚(insert添加方法)

这是什么情况呢,相当于Spring事务策略失效了。

try-catch捕获了异常后,这种业务方法也就等于脱离了spring事务的管理,因为没有任何异常会从业务方法中抛出,全被捕获并“吞掉”,导致spring异常抛出触发事务回滚策略失效。

通俗的来说:默认spring事务只在发生未被捕获的 runtimeexcetpion或error时才回滚。

二、处理方案一

spring aop 异常捕获进而回滚。在catch中最后加上throw new runtimeexcetpion(),这样程序异常时才能被aop捕获进而回滚,缺点是无法return异常信息提示,前端用户交互效果不佳

@Transactional(rollbackFor=Exception.class)  //表示此方法有异常时触发Spring事务
@Override
public CommonResult<User> saveUser(User user) {
    int insert = baseMapper.insert(user);
    try {
        // 添加异常,并进行捕获
        int a = 10/0;
    }catch (Exception e){
        logger.info("异常信息:"+e);
        // 方案一:spring aop 异常捕获
        throw new RuntimeException();
    }
    if(insert > 0){
        return CommonResult.commentSuccess(user);
    }else {
        return CommonResult.commentFailure("添加失败");
    }
}

三、处理方案二

就是让一个方法报异常,另一个方法回滚,这样才能真正的触发Spring事务回滚策略。

catch语句中增加:

TransactionAspectSupport.currentTransactionStatus().setRollbackOnly(); //手动回滚,这样上层就无需去处理异常了

完整代码:

@Transactional(rollbackFor=Exception.class) //表示此方法有异常时触发Spring事务
@Override
 public CommonResult<User> saveUser(User user) {
     int insert = baseMapper.insert(user);
     try {
         // 添加异常,并进行捕获
         int a = 10/0;
     }catch (Exception e){
         logger.info("异常信息:"+e);
         // 方案二:手动回滚
         TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
         return CommonResult.commentFailure("服务器异常,事务回滚");
     }
     if(insert > 0){
         return CommonResult.commentSuccess(user);
     }else {
         return CommonResult.commentFailure("添加失败");
     }
 }

四、如过需要手动进行手动回滚的业务方法比较多,我们可以写一个公共的工具类

SpringRollBackUtil.java

public class SpringRollBackUtil {
    /**
     * 事务回滚机制
     */
    public static void rollBack() {
        try {
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

只需调用方法即可

// 方案三:公共工具类 手动回滚
SpringRollBackUtil.rollBack();

Spring mvc:事务引起的try/catch失效

在测试一个接口时,发现一个奇怪的现象:

该接口使用@ResponseBody注解返回json格式数据,并且使用try/catch包括全部逻辑代码,debug后发现返回数据没有任何错误,只包含一段因产生异常导致的错误提示字符串,但是chrome浏览器network却显示http状态码为500。

最后发现在该RequestMapping方法上还有一个注解@Transactional,去除ok。

以上为个人经验,希望能给大家一个参考。

猜你在找的解决try-catch捕获异常信息后Spring事务失效的问题相关文章

本文主要介绍了maven实现docker自动化部署插件的使用,分享给大家,感兴趣的小伙伴们可以参考一下
今天给大家带来的是关于Java的相关知识,文章围绕着SpringBoot异常处理流程及原理展开,文中有非常详细的介绍及代码示例,需求的大佬可以参考下
了SpringAop日志找不到方法的处理方案,具有很好的参考价值,希望对大家有所帮助。如有错误或未考虑完全的地方,望不吝赐教
今天给大家带来的是关于Java的相关知识,文章围绕着SpringBoot异常处理自动配置展开,文中有非常详细的介绍及代码示例,需求的大佬可以参考下
说到线程的底层运行原理,想必各位也应该知道我们今天不可避免的要讲到JVM 了。其实大家明白了Java的运行时数据区域,也就明白了线程的底层原理,今天带着大家一步一步
今天给大家带来的是关于Java并发编程的相关知识,文章围绕着Executor接口的使用展开,文中有非常详细的介绍及代码示例,需求的大佬可以参考下
代码生成器,可以有效减少编写重复代码,快速实现简单的业务逻辑,也能让我们的代码保持一致。那目前,我们看到的代码生成器,大部分是基于velocity引擎模板生成的,接下来我
今天给大家带来的是关于Java的相关知识总结,文章围绕着JAVA正则表达式及字符串的替换与分解展开,文中有非常详细的介绍及代码示例,需求的大佬可以参考下
Java 有两种代理方式,一种是静态代理,另一种是动态代理。如果我们在代码编译时就确定了被代理的类是哪一个,那么就可以直接使用静态代理;如果不能确定,那么可以使用类
今天给大家带来的是关于Java数据结构的相关知识,文章围绕着Java二叉树展开,文中有非常详细的介绍及代码示例,需求的大佬可以参考下
了SpringBoot与Postman实现REST模拟请求的操作,具有很好的参考价值,希望对大家有所帮助。如有错误或未考虑完全的地方,望不吝赐教
我们知道Java是一个面相对象的编程语言,基本类型并不具有对象的性质,为了让基本类型也具有对象的特征,就出现了包装类型,它相当于将基本类型“包装起来”,使得它具有了